typedef struct {
  float *u;
  float *v;
  float *theta;
  float *phi;
  int   ThetaSamples;	/* Width of array				 */
  int   PhiSamples;	/* Height of array in no. numbers (Real/Complex) */
  int   USamples;
  int   VSamples;
  float Thetamin;
  float Phimin;
  float Umin;
  float Vmin;
  float DeltaTheta;
  float DeltaPhi;
  float DeltaU;
  float DeltaV;
  float *tau_x;
  float *tau_y;
  float *tau_z;
  float *alpha_x;
  float *alpha_y;
  float *alpha_z;
  float *beta_x;
  float *beta_y;
  float *beta_z;
} TrigDef;

typedef struct {
  float *x;
  float *y;
  float *z;
  int  XSamples;	/* Width of array				 */
  int  YSamples;	/* Height of array in no. numbers (Real/Complex) */
  int  ZSamples;
  float Xmin;
  float Ymin;
  float Zmin;
  float DeltaX;
  float DeltaY;
  float DeltaZ;
} XYZDef;

typedef struct {
  int   VolIndex;              /* Index in the signal             */
  float A;                     /* Weight factor in the matrix     */
} VolWeight;								  

extern XYZDef * GenerateXYZ(int, int, int,
			    float, float, float,
			    float, float, float);
extern TrigDef * GenerateTrigDef(int, int, int, int,  
				 float, float, float, float,
				 float, float, float, float);
extern TrigDef *GenerateTrigDef_fromMultiStruct(MultiStruct *);
extern XYZDef *GenerateXYZ_fromMultiStruct(MultiStruct *);
extern XYZDef *GenerateXYZ_fromIniFile(void);




