/* 3dmisc.h */

#define _DHardCore  1
#define _DSilent    2
#define _DNoLog     4
#define _DNormal    8
#define _DDebug    16

#define _LongDate 100
#define _Time     101
#define _RealTime 102
#define _Date     103

#define max(a,b) ((a)>(b) ? (a) : (b))
#define min(a,b) ((a)<(b) ? (a) : (b))
#define sq(a) ((a)*(a))

/***** Generic **************/
#define TRUE		1
#define FALSE		0
#define _RealArray	1     
#define _ComplexArray   2
/****************************/

/******** GetArg ************/
#define _ArgError	0
#define _NoError	1
/****************************/

#define Swap(a,b) {Temp=(a);(a)=(b);(b)=Temp;}
#define Free(x) {if(x) free(x); else Error("Trying to free NULL pointer");}

typedef struct {
  char  WorkDir[100];
  char  Sinogram[100];
  int   SinogramType;
  char  OrgFile[100];
  int   OrgFileType;
  char  Volume[100];
  int   VolumeType;
  char  Function[50];
  char  DebugLevel[50];
  float Iterations;
  float Iterative_Par_1;
  float Iterative_Par_2;
  float Direct_Par_1;
  int   Select_Par_1;
  float Xmin;
  float Ymin;
  float Zmin;
  float DeltaX;
  float DeltaY;
  float DeltaZ;
  int   XSamples;
  int   YSamples;
  int   ZSamples;
} INI3D;

extern int DebugLevel;
extern char LogFileName[100];
extern float multtemp;

extern INI3D IniFile3D;
extern void Read3DArgs(char *);

extern int GetArg(char *, char*, char*);
extern char *ReadIni(char *);
extern void  GetDateTime(char *, int);

extern void OpenLog(char *);
extern void CloseLog(void);
extern void Print(int, char*, ...);
extern void Error(char*, ...);

extern void MultNew(float *,float *,float *);
extern void MultReStore(float *,float *);
extern float *FloatVector(int);
extern int *IntVector(int);

extern void convert2(char *);
extern void convert4(char *);
extern void convert8(char *);
extern void convert_UNIX_PC(char *, int);

extern int NextRadix2(int);
extern int *NextRadix2Vector(int *,int);

extern float MinFloatVector(float *,int);
extern float MaxFloatVector(float *,int);

extern float MaxRealComplexVector(float *,int);
extern float MinRealComplexVector(float *,int);
extern float MaxImagComplexVector(float *,int);
extern float MinImagComplexVector(float *,int);

void ZeroFloatVector(float *,int);








