/*******************************
*   Prototypes for 3dtools.c  *
*******************************/
         
#define _00ND 20036

#define _A3F  200
#define _F3F  300
#define _F4F  400   
#define _A4F  500   

#define _Signal 1000
#define _NoSignal 2000

typedef struct {
  int   Id;              /* Id used to restore F<Dim>F                   */
  int   LengthOfHeader;  /* Length of header in bytes before any vector  */
  int   Dim;             /* Number of dimensions                         */
  int   NoOfSamples;     /* Total number of samples                      */
  int   Type;		 /* Picture type (eg. format on disc, domain)	 */
  char  FileName[160];	 /* Name used for saving/restoring this image	 */
  char  Description[80]; /* eg. short description of image (optional)	 */
  char  Date[8];	 /* Date (DDMMYY) (optional)			 */
  int   ArrayType;	 /* Defines number format: Complex(2) or Real(1) */
  int   *Samples;        /* Pointer to number of samples. Length is Dim  */
  float *Min;            /* Pointer to min positions. Length is Dim      */
  float *Delta;          /* Pointer to sampling distances. Length is Dim */
  float *Signal;         /* Pointer to signal. Length: product of dims   */
} MultiStruct;								  


extern void Real2ComplexMultiStruct(MultiStruct * MyMultiStruct);
extern void AbsMultiStruct(MultiStruct *);
extern void RealMultiStruct(MultiStruct *);
extern void ImagMultiStruct(MultiStruct *);
extern void FreeMultiStruct(MultiStruct *);
extern void ZeroMultiStruct(MultiStruct *);
extern void RenameMultiStruct(MultiStruct *, char *);
extern MultiStruct * NewMultiStruct(char *,int,int *,int);
extern MultiStruct * NewMultiStruct_NoSignal(char *,int,int *,int);
extern MultiStruct * DuplicateMultiStruct(MultiStruct *MyMultiStruct);
extern void InfoMultiStruct(int,MultiStruct *);
extern float MaxMultiStruct(MultiStruct *);
extern float MinMultiStruct(MultiStruct *);
extern MultiStruct * ResizeMultiStruct(MultiStruct *,int *,int *);
extern void FindIndicesInMultiStruct(int *,int *,int,int);
extern int FindSignalIndexInMultiStruct(int *,int *,int);
extern MultiStruct * SliceMultiStruct(MultiStruct *,int *);
extern MultiStruct * SubtractMultiStruct(MultiStruct *,MultiStruct *);
extern MultiStruct * SubtractMultiStruct(MultiStruct *,MultiStruct *);
extern float L2_measure(MultiStruct *,MultiStruct *);
extern void StatMultiStruct(MultiStruct *,float *,float *);










