/* FIF_IO.h */

#define _00EI 17737

typedef struct {
  int  FIFIdType;       /* Id used to restore FIF:17737:'\0''\0''E''I'   */
  char FileName[100];	/* Name used for saving/restoring this image	 */
  char Description[80];	/* eg. short description of image (optional)	 */
  char Date[6];		/* Date (DDMMYY) (optional)			 */
  int  Type;		/* Picture type (eg. format on disc, domain)	 */
  int  M;		/* Width of array				 */
  int  N;		/* Height of array in no. numbers (Real/Complex) */
  int  ArrayType;	/* Defines number fromat: Complex(2) or Real(1)	 */
  float Xmin;		/* Leftmost coor. in original image   		 */
  float Ymin;		/* Lowest coor. in original image	   	 */
  float DeltaX;		/* Quantisation steps in original image	(X)	 */
  float DeltaY;		/* Quantisation steps in original image	(Y)	 */
  float SignalMin;	/* Lowest signalvalue in array			 */
  float SignalMax;	/* Highest signalvalue in array			 */
  float **Signal;	/* The raw data array	 			 */
} Image;								  

extern Image * NewFloatImage(char *, int, int, int);
extern void FreeImage(Image *); 
extern Image * ReadFIF(char *);
extern void WriteFIF(Image *);
extern MultiStruct * FIFs_to_F3F(char *,int,int,float,float);
extern void Write_FIFs_to_F3F(char *,int,int,float,float);
extern Image * F2F_to_Image(MultiStruct *My2D);
extern MultiStruct * Image_to_F2F(Image *MyImage);
